#!/usr/bin/perl
use strict;
use Date::Manip;
use Date::Calc qw(:all);
my @timeData = localtime(time);
my $daylightsaving = $timeData[-1];
sub string2date {
    my ($str) = @_;
    return int(UnixDate($str, "%s")); 
}

sub date2string {
    my ($time) = @_;
    return UnixDate("epoch $time", "%m/%d/%y %H:%M:%S"); 
}

sub date2timezone {
    my ($time, $tz) = @_;
	my $ret;

    $ret = UnixDate(Date_ConvTZ(ParseDate("epoch $time"), '', $tz), '%m/%d/%y %H:%M:%S');
	$ret = -1 unless ($ret);
	return $ret;
}

sub date2midnightSec {
    my ($time) = @_;
    my @a = localtime($time); 
    return 3600*@a[2] + 60*@a[1] + @a[0];
}

sub cal_time() {
	my($y,$m,$d,$H,$M,$S) = Add_Delta_DHMS(Today_and_Now(), 0,9-$daylightsaving,30,0);
	return sprintf("Current time in Adelaide: %04d-%02d-%02d %02d:%02d:%02d",$y,$m,$d,$H,$M,$S);
}
sub check($$$){
	my ($server, $channel, $msg) = @_;
	if($msg  =~ m#^!adel$#) {
		my $chan = $server->channel_find($channel);
		$chan->command("/SAY ". cal_time()) if $chan;
	} elsif($msg =~ m#^![A-Z]+$#) {
		$msg =~ s#!##;
		chomp $msg;
		my $ret = date2timezone(string2date("now"), $msg);
		my $chan = $server->channel_find($channel);
		return if ($ret == -1 or !$chan);
		$chan->command("/SAY $msg: $ret") ;
	}
}
sub say_time{
	my ($server, $msg, $nick, $address, $channel) = @_;
	check($server, $channel, $msg);
}
sub say_time_own{
	my ($server, $msg, $channel) = @_;
	check($server, $channel, $msg);
}
sub adel {
	my ($data, $server, $witem) = @_;
	$witem->command("ECHO " . cal_time()) if $witem;
	Irssi::print(cal_time()) if !$witem;
}
Irssi::signal_add_last('message public', 'say_time');
Irssi::signal_add_last('message own_public', 'say_time_own');
Irssi::command_bind('adel', 'adel');

